function TPCSAExtensions()
	local function DefaultLanguages()
		Diablos.CS.Strings = {
			busschedule = "BUS SCHEDULE",
			busdriver = "BUS DRIVER",
			busdrivers = "BUS DRIVERS",
			ticketprice = "Ticket price",
			caption = "Caption",
			currentbusstop = "Current bus stop",
			busiscomingto = "Bus is coming to",
			nameofnpc = "NPC Bus driver",
			arentauthorize = "You aren't authorize to see the bus panel!",
			notenoughplayers = "There is not enough players in the server to do what you want!",
			takeabus = "TAKE A BUS",
			earn = "You will earn",
			all = "all",
			minute = "minute(s)",
			all2 = "all",
			busstops = "bus stop(s) reached",
			bringvehicle = "Bring the vehicle where it spawned when you want to finish your work",
			takemybus = "TAKE MY BUS",
			cantdoiftoofar = "You can't take a bus if you are too far from the NPC!",
			notenoughmoney = "You can't take a bus if you don't have enough money!",
			youpaid = "You paid",
			yourdestinationis = "Your destination is:",
			shouldtakevehicle = "You should take the vehicle which just spawned!",
			destination = "Destination:",
			distance = "Distance:",
			youwin = "You win",
			citybussystem = "CITYBUS SYSTEM",
			busstop = "Bus Stop",
			invalidplayer = "Invalid player",
			nobodyrequests = "Nobody requests for a ticket!",
			nobodyinbus = "Nobody is in your bus!",
			nocitybuspanel = "Bus not provided with a citybus panel!",
			giveticket = "GIVE",
			ticketrequested = "You requested a ticket!",
			ticketbought = "Your ticket has been bought",
			notenoughforticket = "You don't have enough money to buy this ticket!",
			playernotenoughmoney = "The player can't buy a ticket because he doesn't have enough money!",
			boughtfor = "for",
			eject = "EJECT",
			havebeenejected = "You have been ejected by the bus driver!",
			nopassager = "NO PASSAGER",
			peopleinbus = "People who are in your bus:",
			peoplewantticket = "People who want a ticket:",
			takebuspause = "TAKE BUS PAUSE",
			istakingpause = "The bus driver is taking a pause.",
			stopwork = "You have stopped your work!",
			stopyourwork = "If you want to stop your work",
			continuework = "Let's go back to work!",
			workfinished = "Your work is finished!",
		}
	end

	DefaultLanguages()

	local scrid, scrver = "4091", "2.0.0"
	local lng = string.lower(Diablos.CS.Language)
	local codename = "tpcsa"

	if SERVER then
		if Diablos.CS.Download.FastDL then
			resource.AddFile("materials/models/alien_nl/busstop/busstop.vtf")
			resource.AddFile("materials/models/alien_nl/busstop/glass.vtf")
			resource.AddFile("materials/models/alien_nl/busstop/metal.vtf")
			resource.AddFile("materials/tpcsa/busmat.png")
			resource.AddFile("models/alien_nl/busstop/busstop.mdl")
		end
		if Diablos.CS.Download.Workshop then
			resource.AddWorkshop("931384439") -- The Perfect Citybus System Assets
		end

		hook.Add("InitPostEntity", "IniDiablos" .. scrid .. "Version", function()
			timer.Simple(0, function()
				http.Fetch("http://diabloscoder.com/gmod/contents/versions.txt",
					function(body, _, _, _)
						local vernum = string.find(body, codename)
						local endver = string.find(body, ";", vernum)
						local realver = string.sub(body, vernum + 6, endver - 1)
						if realver == scrver then
							MsgC(Color(0, 255, 0), "[Script - ID:" .. scrid .. "] : Addon up-to-date. Thanks for using it.\n")
						else
							MsgC(Color(255, 0, 0), "[Script - ID:" .. scrid .. "] : Your addon is not up-to-date. Your version is " .. scrver .. " and the most recent one is " .. realver .. ".\n")
						end
					end
				)
			end)
		end)
	end

	timer.Simple(0, function()
		-- Don't try to tell me you are a pro coder and you should remove the http code below. Remove it will avoid the server to receive
		-- the strings depending of the language you use. It only take the language strings, nothing else. If you are a leaker don't worry about it.
		http.Fetch("http://diabloscoder.com/gmod/lang/" .. codename .. "/" .. lng .. ".txt",
			function(body, _, _, _)
				if not string.find(body, "Strings = {") then
					MsgC(Color(255, 0, 0), "[Script ID:" .. scrid .. "] : You typed incorrectly the value of the language in the configuration file!\nLanguage will be English. More informations at http://diabloscoder.com/languages.\n")
				else
					RunString(body)
					MsgC(Color(0, 255, 0), "[Script - ID:" .. scrid .. "] : " .. string.upper(string.sub(lng, 1, 1)) .. string.sub(lng, 2) .. " strings of the script have been successfully launched.\n")
				end
			end,
			function(err)
				MsgC(Color(255, 0, 0), "[Script - ID:" .. scrid .. "] : Host not found for a Diablos script - language will be English.\nContact him on GModStore for a quick help!\n")
			end
		)
	end)
end