include("shared.lua")

surface.CreateFont("DiablosCSBusStopFont", { font = "Calibri", size = 80, weight = 500 })
surface.CreateFont("DiablosCSBusStopFont2", { font = "Calibri", size = 60, weight = 500 })
surface.CreateFont("DiablosCSAboveHeadFont", { font = "Calibri", size = 60, weight = 400 })
surface.CreateFont("DiablosCSMainFont", { font = "Calibri", size = 18, weight = 400 })

local col = {
	w = Color(255, 255, 255),
	b = Color(0, 0, 0),
}

local function findTeamByJobName(jobName)
	for id,job in pairs(RPExtraTeams) do
		if job.name == jobName then
			return id
		end
	end
	return nil
end

local busmat = Material("tpcsa/busmat.png")

local tblid, busstops = {}, {}

local ctab = 0

net.Receive("TPCSA:UpdInfos", function(len, ply)
	tblid = net.ReadTable()
	busstops = net.ReadTable()
	ctab = table.Count(busstops)
end)


function ENT:Draw()
	self:DrawModel()

	if LocalPlayer():GetPos():DistToSqr(self:GetPos()) > Diablos.CS.Optimization * 10000 then return end

	local ang = self:GetAngles()

	ang:RotateAroundAxis(ang:Forward(), 90)
	ang:RotateAroundAxis(ang:Right(), 180)

	cam.Start3D2D(self:GetPos() + self:GetUp() * 75 + self:GetRight() * 73 + self:GetForward() * 22, ang, .05)
		draw.RoundedBox(2, 0, 0, 859, 1260, Diablos.CS.Colors.BoxesCurrent)
		draw.RoundedBox(2, 10, 10, 839, 1240, col.w)
		local center = 429.5

		surface.SetFont("DiablosCSBusStopFont")
		local sizex1 = surface.GetTextSize(Diablos.CS.Strings.busschedule)
		draw.SimpleText(Diablos.CS.Strings.busschedule, "DiablosCSBusStopFont", center, 10, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)

		draw.RoundedBox(2, center - sizex1 / 2 - 10, 90, sizex1 + 20, 3, col.b)
		local busdrivertxt = Diablos.CS.Strings.busdriver
		local numbusdriver = team.NumPlayers(findTeamByJobName(Diablos.CS.BusDriverTeam))
		if numbusdriver > 1 then busdrivertxt = Diablos.CS.Strings.busdrivers end
		draw.SimpleText(numbusdriver .. " " .. busdrivertxt, "DiablosCSBusStopFont", center, 100, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)

		local posy = 2.2
		if Diablos.CS.TicketPrice > 0 then
			draw.SimpleText(Diablos.CS.Strings.ticketprice .. ": " .. GAMEMODE.Config.currency .. Diablos.CS.TicketPrice, "DiablosCSBusStopFont2", center, 180, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
			posy = 2.8
		end
		local pos = self:GetPos()
		local dir = true
		surface.SetDrawColor(Diablos.CS.Colors.LinesDestination) surface.DrawRect(10, posy * 100 - 20, 839, 5)
		for id, ent in pairs(busstops) do
			local posx = 0
			if dir then posx = 30 else posx = 449 end
			if id == ctab and ctab % 2 != 0 then posx = 239.5 end
			local val = tblid[id]
			local diff = 5
			if ent.id == self:GetIDBusStop() then
				surface.SetDrawColor(Diablos.CS.Colors.BoxesCurrent) surface.DrawRect(posx, posy * 100, 380, 80)
				if val then
					surface.SetDrawColor(Diablos.CS.Colors.BoxesIsGoing) surface.DrawRect(posx + 5, posy * 100 + 5, 370, 70)
					diff = 10
				end
			else
				if val then
					surface.SetDrawColor(Diablos.CS.Colors.BoxesIsGoing) surface.DrawRect(posx, posy * 100, 380, 80)
				end
			end
			surface.SetDrawColor(Diablos.CS.Colors.BackgroundDestination) surface.DrawRect(posx + diff, posy * 100 + diff, 380 - diff * 2, 80 - diff * 2)

			draw.SimpleText(ent.name, "DiablosCSBusStopFont2", posx + 190, posy * 100 + 10, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
			if not dir then posy = posy + 1 end
			if id == ctab then posy = posy + 1 end
			dir = !dir
		end

		local posye = posy * 100
		surface.SetDrawColor(Diablos.CS.Colors.LinesDestination)
		surface.DrawRect(10, posye, 839, 5)
		surface.DrawRect(10, posye + 10, 839, 5)

		draw.SimpleText(Diablos.CS.Strings.caption .. ":", "DiablosCSBusStopFont2", center, posye + 15, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)

		surface.SetFont("DiablosCSBusStopFont2")
		local sizex2 = surface.GetTextSize(Diablos.CS.Strings.currentbusstop)
		local sizex3 = surface.GetTextSize(Diablos.CS.Strings.busiscomingto)

		if ctab < 15 then
			draw.RoundedBox(2, center - sizex2 / 2 - 20, posye + 90, sizex2 + 40, 60, Diablos.CS.Colors.BoxesCurrent)
			draw.RoundedBox(2, center - sizex2 / 2 - 16, posye + 94, sizex2 + 32, 52, col.w)
			draw.SimpleText(Diablos.CS.Strings.currentbusstop, "DiablosCSBusStopFont2", center, posye + 90, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)

			draw.RoundedBox(2, center - sizex3 / 2 - 20, posye + 180, sizex3 + 40, 60, Diablos.CS.Colors.BoxesIsGoing)
			draw.RoundedBox(2, center - sizex3 / 2 - 16, posye + 184, sizex3 + 32, 52, col.w)
			draw.SimpleText(Diablos.CS.Strings.busiscomingto, "DiablosCSBusStopFont2", center, posye + 180, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)

		else
			draw.RoundedBox(2, 30, posye + 90, 370, 60, Diablos.CS.Colors.BoxesCurrent)
			draw.RoundedBox(2, 34, posye + 94, 362, 52, col.w)
			draw.SimpleText(Diablos.CS.Strings.currentbusstop, "DiablosCSBusStopFont2", 215, posye + 90, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)

			
			draw.RoundedBox(2, 449, posye + 90, 370, 60, Diablos.CS.Colors.BoxesIsGoing)
			draw.RoundedBox(2, 453, posye + 94, 362, 52, col.w)
			draw.SimpleText(Diablos.CS.Strings.busiscomingto, "DiablosCSBusStopFont2", 634, posye + 90, col.b, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
		end

		surface.SetDrawColor(Diablos.CS.Colors.LinesDestination) surface.DrawRect(10, posye + 250, 839, 10)

		draw.SimpleText(Diablos.CS.BusStopPanelText, "DiablosCSBusStopFont2", 845, 1190, col.b, TEXT_ALIGN_RIGHT, TEXT_ALIGN_LEFT)
	cam.End3D2D()

	ang:RotateAroundAxis(ang:Right(), 180)

	cam.Start3D2D(self:GetPos() + self:GetUp() * 75 + self:GetRight() * 80 + self:GetForward() * -21, ang, .05)
		draw.RoundedBox(2, 0, 0, 859, 1260, Diablos.CS.Colors.BoxesCurrent)
		surface.SetDrawColor(col.w)
		surface.SetMaterial(busmat)
		surface.DrawTexturedRect(10, 10, 839, 1240)
	cam.End3D2D()

	ang:RotateAroundAxis(ang:Right(), -90)

	cam.Start3D2D(self:GetPos() + self:GetUp() * 88.6 + self:GetRight() * 79.5 + self:GetForward() * 31.5, ang, .05)
		surface.SetDrawColor(col.b) surface.DrawRect(0, 0, 3014, 81)
	cam.End3D2D()

	cam.Start3D2D(self:GetPos() + self:GetUp() * 95 + self:GetRight() * 79.5 + self:GetForward() * 31.5, ang, .08)
		surface.SetFont("DiablosCSBusStopFont")
		local sizex = surface.GetTextSize(self:GetNameBusStop())
		draw.SimpleText(self:GetNameBusStop(), "DiablosCSBusStopFont", 950, 0, col.w, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
		draw.RoundedBox(8, 950 - sizex / 2 - 30, 80, sizex + 60, 2, col.w)
	cam.End3D2D()
end